
#ifndef P18FUSB_CFG_H
#define P18FUSB_CFG_H


//
// Config
//




//
// 4 Mhz Xtal
//


#if	  XTAL_FREQ	== 4L
									//	96MHz PLL Prescaler:
#pragma config PLLDIV 	= 1			//		1: No divide (4MHz input)
									//	Full-Speed USB Clock Source Selection:
#pragma config USBDIV 	= 2			// 		2:	Clock source from 96MHz PLL/2


#if	   CPU_FREQ == 1.0
		#pragma config FOSC 	= XT_XT		//		XT_XT:		XT oscillator, XT used by USB
		#pragma config CPUDIV 	= OSC4_PLL6	//		OSC4_PLL6:	[OSC1/OSC2 Src: /4][96MHz PLL Src: /6]
#elif  CPU_FREQ == 1.33
		#pragma config FOSC 	= XT_XT		//		XT_XT:		XT oscillator, XT used by USB
		#pragma config CPUDIV 	= OSC3_PLL4	//
#elif  CPU_FREQ == 2.0
		#pragma config FOSC 	= XT_XT		//		XT_XT:		XT oscillator, XT used by USB
		#pragma config CPUDIV 	= OSC2_PLL3	//		OSC2_PLL3:	[OSC1/OSC2 Src: /2][96MHz PLL Src: /3]
#elif  CPU_FREQ == 4.0
		#pragma config FOSC 	= XT_XT		//		XT_XT:		XT oscillator, XT used by USB
		#pragma config CPUDIV 	= OSC1_PLL2	//		OSC1_PLL2:	[OSC1/OSC2 Src: /1][96MHz PLL Src: /2]
#elif CPU_FREQ == 16.0
		#pragma config CPUDIV 	= OSC4_PLL6	//		OSC4_PLL6:	[OSC1/OSC2 Src: /4][96MHz PLL Src: /6]
		#pragma config FOSC 	= XTPLL_XT	//		XTPLL_XT:	XT oscillator, PLL enabled, XT used by USB
#elif CPU_FREQ == 24.0
		#pragma config CPUDIV 	= OSC3_PLL4	//		OSC1_PLL4:	[OSC1/OSC2 Src: /3][96MHz PLL Src: /4]
		#pragma config FOSC 	= XTPLL_XT	//		XTPLL_XT:	XT oscillator, PLL enabled, XT used by USB
#elif CPU_FREQ == 32.0
		#pragma config CPUDIV 	= OSC2_PLL3	//		OSC1_PLL3:	[OSC1/OSC2 Src: /2][96MHz PLL Src: /3]
		#pragma config FOSC 	= XTPLL_XT	//		XTPLL_XT:	XT oscillator, PLL enabled, XT used by USB
#elif CPU_FREQ == 48.0
		#pragma config CPUDIV 	= OSC1_PLL2	//		OSC1_PLL2:	[OSC1/OSC2 Src: /1][96MHz PLL Src: /2]
		#pragma config FOSC 	= XTPLL_XT	//		XTPLL_XT:	XT oscillator, PLL enabled, XT used by USB
#else
#error Verkeerde _CPU_FREQ voor _XTAL_FREQ == 4 (1,1.33,2,4,16,24,32,48)
#endif


//
// 12 Mhz Xtal
//


#elif XTAL_FREQ == 12L
									//	96MHz PLL Prescaler:
#pragma config PLLDIV 	= 3			//		3: Divide by 3 (12MHz input)
									//	Full-Speed USB Clock Source Selection:
#pragma config USBDIV 	= 2			// 		2:	Clock source from 96MHz PLL/2


#if	   CPU_FREQ == 3.0
		#pragma config FOSC 	= HS		//		HS:			HS oscillator, HS used by USB
		#pragma config CPUDIV 	= OSC4_PLL6	//		OSC4_PLL6:	[OSC1/OSC2 Src: /4][96MHz PLL Src: /6]
#elif  CPU_FREQ == 4.0
		#pragma config FOSC 	= HS		//		HS:			HS oscillator, HS used by USB
		#pragma config CPUDIV 	= OSC3_PLL4	//		OSC3_PLL4:	[OSC1/OSC2 Src: /3][96MHz PLL Src: /4]
#elif  CPU_FREQ == 6.0
		#pragma config FOSC 	= HS		//		HS:			HS oscillator, HS used by USB
		#pragma config CPUDIV 	= OSC2_PLL3	//		OSC2_PLL3:	[OSC1/OSC2 Src: /2][96MHz PLL Src: /3]
#elif  CPU_FREQ == 12.0
		#pragma config FOSC 	= HS		//		HS:			HS oscillator, HS used by USB
		#pragma config CPUDIV 	= OSC1_PLL2	//		OSC11_PLL2:	[OSC1/OSC2 Src: /1][96MHz PLL Src: /2]
#elif  CPU_FREQ == 16.0
		#pragma config FOSC 	= HSPLL_HS	//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
		#pragma config CPUDIV 	= OSC4_PLL6	//		OSC4_PLL6:	[OSC1/OSC2 Src: /4][96MHz PLL Src: /6]
#elif CPU_FREQ == 24.0
		#pragma config FOSC 	= HSPLL_HS	//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
		#pragma config CPUDIV 	= OSC3_PLL4	//		OSC3_PLL4:	[OSC1/OSC2 Src: /3][96MHz PLL Src: /4]
#elif CPU_FREQ == 32.0
		#pragma config FOSC 	= HSPLL_HS	//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
		#pragma config CPUDIV 	= OSC2_PLL3	//		OSC2_PLL3:	[OSC1/OSC2 Src: /2][96MHz PLL Src: /3]
#elif CPU_FREQ == 48.0
		#pragma config FOSC 	= HSPLL_HS	//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
		#pragma config CPUDIV 	= OSC1_PLL2	//		OSC1_PLL2:	[OSC1/OSC2 Src: /1][96MHz PLL Src: /2]
#else
#error Verkeerde _CPU_FREQ voor _XTAL_FREQ == 12 (3,4,6,12,16,24,32,48)
#endif


//
// 20 Mhz Xtal
//


#elif XTAL_FREQ == 20L
									//	96MHz PLL Prescaler:
#pragma config PLLDIV 	= 5			//		5: Divide by 5 (20MHz input)
									//	Full-Speed USB Clock Source Selection:
#pragma config USBDIV 	= 2			// 		2:	Clock source from 96MHz PLL/2


#if	   CPU_FREQ == 5.0
		#pragma config FOSC 	= HS		//		HS:			HS oscillator, HS used by USB
		#pragma config CPUDIV 	= OSC4_PLL6	//		OSC4_PLL6:	[OSC1/OSC2 Src: /4][96MHz PLL Src: /6]
#elif  CPU_FREQ == 6.66
		#pragma config FOSC 	= HS		//		HS:			HS oscillator, HS used by USB
		#pragma config CPUDIV 	= OSC3_PLL4	//		OSC3_PLL4:	[OSC1/OSC2 Src: /3][96MHz PLL Src: /4]
#elif  CPU_FREQ == 10.0
		#pragma config FOSC 	= HS		//		HS:			HS oscillator, HS used by USB
		#pragma config CPUDIV 	= OSC2_PLL3	//		OSC2_PLL3:	[OSC1/OSC2 Src: /2][96MHz PLL Src: /3]
#elif CPU_FREQ == 16.0
		#pragma config FOSC 	= HSPLL_HS	//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
		#pragma config CPUDIV 	= OSC4_PLL6	//		OSC4_PLL6:	[OSC1/OSC2 Src: /4][96MHz PLL Src: /6]
#elif  CPU_FREQ == 20.0
		#pragma config FOSC 	= HS		//		HS:			HS oscillator, HS used by USB
		#pragma config CPUDIV 	= OSC1_PLL2	//		OSC1_PLL2:	[OSC1/OSC2 Src: /1][96MHz PLL Src: /2]
#elif CPU_FREQ == 24.0
		#pragma config FOSC 	= HSPLL_HS	//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
		#pragma config CPUDIV 	= OSC3_PLL4	//		OSC3_PLL4:	[OSC1/OSC2 Src: /3][96MHz PLL Src: /4]
#elif CPU_FREQ == 32.0
		#pragma config FOSC 	= HSPLL_HS	//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
		#pragma config CPUDIV 	= OSC2_PLL3	//		OSC2_PLL3:	[OSC1/OSC2 Src: /2][96MHz PLL Src: /3]
#elif CPU_FREQ == 48.0
		#pragma config FOSC 	= HSPLL_HS	//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
		#pragma config CPUDIV 	= OSC1_PLL2	//		OSC1_PLL2:	[OSC1/OSC2 Src: /1][96MHz PLL Src: /2]
#else
#error Verkeerde _CPU_FREQ voor _XTAL_FREQ == 20 (5,6.66,10,16,20,24,32,48)
#endif



//
// 48 Mhz Xtal
//

#elif XTAL_FREQ == 48L
									//	96MHz PLL Prescaler:
#pragma config PLLDIV 	= 12		//		12: Divide by 12 (48MHz input)	
									//	Full-Speed USB Clock Source Selection:
#pragma config USBDIV 	= 2			// 		2:	Clock source from 96MHz PLL/2

#else
#error Ongeldige _XTAL_FREQ 
#endif


//pragma config PLLDIV 	= 1			//	96MHz PLL Prescaler:
									//		1: No divide (4MHz input)
									//		2: Divide by 2 (8MHz input)
									//		3: Divide by 3 (12MHz input)
									//		4: Divide by 4 (16MHz input)
									//		5: Divide by 5 (20MHz input)
									//		6: Divide by 6 (24MHz input)
									//		10: Divide by 10 (40MHz input)
									//		12: Divide by 12 (48MHz input)
//#pragma config CPUDIV = OSC1_PLL2	//	CPU System Clock Postscaler:
									//		OSC1_PLL2:	[OSC1/OSC2 Src: /1][96MHz PLL Src: /2]
									//		OSC2_PLL3:	[OSC1/OSC2 Src: /2][96MHz PLL Src: /3]
									//		OSC3_PLL4:	[OSC1/OSC2 Src: /3][96MHz PLL Src: /4]
									//		OSC4_PLL6:	[OSC1/OSC2 Src: /4][96MHz PLL Src: /6]
//#pragma config USBDIV 	= 2			//	Full-Speed USB Clock Source Selection:
									// 		1:	Clock source from OSC1/OSC2
									// 		2:	Clock source from 96MHz PLL/2

//Brrpragma config FOSC 	= HS		//	Oscillator Selection bits
									//		XT_XT:		XT oscillator, XT used by USB
									//		XTPLL_XT:	XT oscillator, PLL enabled, XT used by USB
									//		ECIO_EC:	External clock, port function on RA6, EC used by USB
									//		EC_EC:		External clock, CLKOUT on RA6, EC used by USB
									//		ECPLLIO_EC:	External clock, PLL enabled, port function on RA6, EC used by USB
									//		ECPLL_EC:	External clock, PLL enabled, CLKOUT on RA6, EC used by USB
									//		INTOSCIO_EC:Internal oscillator, port function on RA6, EC used by USB
									//		INTOSC_EC:	Internal oscillator, CLKOUT on RA6, EC used by USB
									//		INTOSC_XT:	Internal oscillator, XT used by USB
									//		INTOSC_HS:	Internal oscillator, HS used by USB
									//		HS:			HS oscillator, HS used by USB
									//		HSPLL_HS:	HS oscillator, PLL enabled, HS used by USB
//#pragma config FCMEM 	= OFF		//	Fail Safe Clock Monitor
#pragma config IESO 	= OFF		//	Internal/External Switch Over
#pragma config PWRT 	= OFF		//	Power Up Timer
#pragma config BOR 		= OFF		//	Brown Out Reset:
									//		OFF:		Disabled
									//		SOFT:		Controlled by SBOREN
									//		ON_ACTIVE: 	Enabled when the device is not in SLEEP, SBOREN bit is disabled
									//		ON:			Enabled, SBOREN bit is disabled
//#pragma config BORV 	= 46		//	Brown Out Voltage:
#pragma config BORV 	= 1			//	Brown Out Voltage:
									//	1	46:	4.6V
									//	2	43:	4.3V
									// 	3	28:	2.8V
									//  4	21:	2.1V
#pragma config VREGEN 	= ON		//	USB Voltage Regulator Enable
#pragma config WDT 		= OFF		//	Watchdog Timer
#pragma config WDTPS 	= 32768		//	Watchdog Postscaler
									//		1,2,4,8..16384,32768
#pragma config MCLRE 	= ON		//	MCLR Enable
#pragma config LPT1OSC 	= OFF		//	Low Power Timer1 Oscillator 
#pragma config PBADEN 	= OFF		//	Port B A/D Enable
									//		OFF: PortB<4:0> pins are configured as digital I/O on RESET
									//		ON:	 PortB<4:0> pins are configured as analog input on RESET
#pragma config CCP2MX 	= ON		//	CCP2 Mux bit
									// 		OFF: CCP2 input/output is multiplexed with RB3
									//		ON:  CCP2 input/output is multiplexed with RC1
#pragma config STVREN 	= ON		//	Stack Overflow Reset
#pragma config LVP 		= OFF		//	Low Voltage ICSP
//#pragma config ICPRT 	= OFF		//	Dedicated In-Circuit Debug/Programming Enable
#pragma config XINST 	= OFF		//	Extended Instruction Set Enable
#pragma config DEBUG 	= OFF		//	Background Debugger Enable
#pragma config CP0 		= OFF		//	Code Protection Block 0,1,2,3
#pragma config CP1 		= OFF
#pragma config CP2 		= OFF
//#pragma config CP3 		= OFF 
#pragma config CPB 		= OFF 		//	Boot Block Code Protection
#pragma config CPD 		= OFF		//	Data EEPROM Code Protection
#pragma config WRT0 	= OFF		//	Write Protection Block 0,1,2,3
#pragma config WRT1 	= OFF 
#pragma config WRT2 	= OFF
//#pragma config WRT3 	= OFF
#pragma config WRTB 	= OFF		//	Boot Block Write Protection
#pragma config WRTC 	= OFF		//	Configuration Register Write Protection
#pragma config WRTD 	= OFF		//	Data EEPROM Write Protection
#pragma config EBTR0 	= OFF 		//	Table Read Protection Block 0,1,2,3
#pragma config EBTR1 	= OFF 
#pragma config EBTR2 	= OFF 
//#pragma config EBTR3 	= OFF 
#pragma config EBTRB 	= OFF 		//	Boot Block Table Read Protection



#endif // P18FUSB_CFG_H

